%define ALD_Ver		2.0

#USE gcc-10.5.0

%define OrgName newlib
%define ARMTREV arm_m10

Name:         %{OrgName}-%{ARMTREV}
License:      GPL LGPL BSD
Summary:      This is newlib, a simple ANSI C library
Version:      4.2.0
Release:      2s

#ftp://sourceware.org/pub/newlib/
#https://sourceware.org/pub/newlib/

autoreqprov: 0
BuildArch:    noarch

Source: %{OrgName}-%{version}.20211231.tar.xz
Source1: %{OrgName}-%{version}-patches.tgz

%define DestDir		/Cross/%{ARMTREV}

# -----------------------------------------------------
#%if %{_target_cpu} != %{_build_cpu}
#ERROR: target_cpu=%{_target_cpu} is not build_cpu=%{_build_cpu}
#%endif

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

#------------------ CROSS DIR --------------------
%define MathSrcDir	/usr

%define docdir %{_defaultdocdir}/%{name}

%define target arm-none-eabi
%define _gccdir %{_libdir}/gcc/%{target}/%{version}

%define __os_install_post %{nil}

%define CrossPath /cross/%{ARMTREV}

%define _prefix %{CrossPath}/usr
%define _bindir %{CrossPath}/bin
%define _libdir %{CrossPath}/usr/lib

#------------------ CROSS DIR --------------------

%define docdir %{_defaultdocdir}/%{name}

# ------------------- description ------------------------------------
%description
arm libc - a Small C Library for Linux
#-------------------------------
%package libc
Summary:      arm libc - a Small C Library for Linux
Requires:     %{name} = %{version}-%{release}
autoreqprov: 0
%description libc
arm libc - a Small C Library for Linux
#-------------------------------
%package libc_nano
Summary:      arm libc - a Small C Library for Linux
Requires:     %{name} = %{version}-%{release}
autoreqprov: 0
%description libc_nano
arm libc - a Small C Library for Linux
#-------------------------------
%package misc
Summary:      arm libc - a Small C Library for Linux
Requires:     %{name} = %{version}-%{release}
autoreqprov: 0
%description misc
arm libc - a Small C Library for Linux



# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{OrgName}-%{version}.20211231

cp newlib/Makefile.in newlib/Makefile.in_orig

tar -xzf %SOURCE1
patch -b -z .orig -p0<patches/nano-mallocr.patch

patch -b -z .orig -p0<patches/mk_libc_nano.patch

sed -i s:"sleep 1":: newlib/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/configure
sed -i s:"sleep 1":: newlib/libc/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/libc/configure

sed -i s:"sleep 1":: newlib/libc/machine/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/libc/machine/configure

sed -i s:"sleep 1":: newlib/libc/machine/aarch64/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/libc/machine/aarch64/configure
sed -i s:"sleep 1":: newlib/libc/machine/amdgcn/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/libc/machine/amdgcn/configure
sed -i s:"sleep 1":: newlib/libc/machine/arm/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/libc/machine/arm/configure

sed -i s:"sleep 1":: newlib/libc/sys/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/libc/sys/configure

sed -i s:"sleep 1":: newlib/libc/sys/arm/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/libc/sys/arm/configure

sed -i s:"sleep 1":: newlib/libm/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/libm/configure

sed -i s:"sleep 1":: newlib/libm/machine/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/libm/machine/configure

sed -i s:"sleep 1":: newlib/libm/machine/arm/configure
sed -i s:"\"\$2\" = conftest.file":"true": newlib/libm/machine/arm/configure


sed -i s:"# directory).":"# directory).\nif false ; then": libgloss/configure
sed -i s:"rm -f conftest.file":"rm -f conftest.file\nfi": libgloss/configure
sed -i s:"     wait ":"   true # wait ": libgloss/configure

sed -i s:" -O2 -g":: libgloss/config/default.mh
sed -i s:" -O2":: libgloss/config/default.mh

# ------------------- Build ------------------------------------------
%Build
PATH=%{CrossPath}/bin:$PATH
GCC_NoHostPath=d
export PATH GCC_NoHostPath

export CC=%{target}-gcc
export CFLAGS="-Os -ffunction-sections -fdata-sections"

%if 1
rm -r -f hard
rm -r -f thumb

rm -r -f z_newlib
mkdir z_newlib
cd z_newlib

../newlib/configure \
  --build=%{_build} \
  --host=%{target} \
  --target=%{target} \
  --prefix=%{_prefix} \
  --exec-prefix=%{_prefix} \
  --libdir=%{_libdir} \
  --includedir=%{_includedir} \
  --disable-silent-rules \
  --disable-shared \
  --enable-multilib \
  --disable-newlib-supplied-syscalls \
  --enable-newlib-reent-check-verify \
  --enable-newlib-reent-small \
  --enable-newlib-retargetable-locking \
  --disable-newlib-fvwrite-in-streamio \
  --disable-newlib-fseek-optimization \
  --disable-newlib-wide-orient \
  --enable-newlib-nano-malloc \
  --disable-newlib-unbuf-stream-opt \
  --enable-lite-exit \
  --enable-newlib-global-atexit \
  --enable-newlib-nano-formatted-io \
  --disable-nls \
  &>FConfigure_log.txt

make -j &>FMake_log.txt

cd ..
%endif

%if 1
cp newlib/Makefile.in_orig newlib/Makefile.in
patch -b -z .orig -p0<patches/mk_libc.patch

#rm -r -f z_newlib
#mkdir z_newlib
cd z_newlib
make clean &>FMake_clean.txt


../newlib/configure \
  --build=%{_build} \
  --host=%{target} \
  --target=%{target} \
  --prefix=%{_prefix} \
  --exec-prefix=%{_prefix} \
  --libdir=%{_libdir} \
  --includedir=%{_includedir} \
  --disable-silent-rules \
  --disable-shared \
  --enable-multilib \
  --enable-newlib-io-long-long \
  --enable-newlib-io-c99-formats \
  --enable-newlib-reent-check-verify \
  --enable-newlib-register-fini \
  --enable-newlib-retargetable-locking \
  --disable-newlib-supplied-syscalls \
  --disable-nls \
  &>FConfigure_log.txt

make -j &>FMake_log.txt
cd ..
%endif

%if 1
export CFLAGS="-Os -ffunction-sections -fdata-sections -I$PWD/z_newlib/targ-include -I$PWD/z_newlib/targ-include/machine -I$PWD/newlib/libc/include -I%{_includedir}"

rm -r -f z_libgloss
mkdir z_libgloss
cd z_libgloss

../libgloss/configure \
  --build=%{_build} \
  --host=%{target} \
  --target=%{target} \
  --prefix=%{_prefix} \
  --exec-prefix=%{_prefix} \
  --libdir=%{_libdir} \
  --includedir=%{_includedir} \
  --disable-silent-rules \
  --disable-shared \
  --enable-multilib \
  --disable-newlib-supplied-syscalls \
  &>FConfigure_log.txt

make -j &>FMake_log.txt

cd ..
%endif

# ------------------- Install ----------------------------------------
%Install
%if 1
export PATH=$PATH:%{CrossPath}/bin

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

cd z_newlib
make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
cd ..

%if 1
cd z_libgloss
make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
cd ..
%endif

cp -a COPYING.NEWLIB $RPM_BUILD_ROOT%{docdir}/
ln -s /usr/share/doc/gpl-2.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING
ln -s /usr/share/doc/lgpl-2.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING.LIB
ln -s /usr/share/doc/gpl-3.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING3
ln -s /usr/share/doc/lgpl-3.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING3.LIB


mv $RPM_BUILD_ROOT%{_prefix}/%{target}/include $RPM_BUILD_ROOT%{_prefix}/
mv $RPM_BUILD_ROOT%{_prefix}/%{target}/lib $RPM_BUILD_ROOT%{_prefix}/
rm -r $RPM_BUILD_ROOT%{_prefix}/%{target}
%endif

# ------------------- Clean ------------------------------------------
%Clean
%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=0 \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
%dir %{_libdir}
%{_libdir}/libm.a
%{_libdir}/libnosys.a

%dir %{_libdir}/arm
%dir %{_libdir}/arm/v5te

%dir %{_libdir}/arm/v5te/hard
%{_libdir}/arm/v5te/hard/libm.a
%{_libdir}/arm/v5te/hard/libnosys.a

%dir %{_libdir}/arm/v5te/softfp
%{_libdir}/arm/v5te/softfp/libm.a
%{_libdir}/arm/v5te/softfp/libnosys.a

%dir %{_libdir}/thumb
%dir %{_libdir}/thumb/nofp

%{_libdir}/thumb/nofp/libm.a
%{_libdir}/thumb/nofp/libnosys.a

%dir %{_libdir}/thumb/v6-m
%dir %{_libdir}/thumb/v6-m/nofp

%dir %{_libdir}/thumb/v7
%dir %{_libdir}/thumb/v7/nofp

%dir %{_libdir}/thumb/v7+fp
%dir %{_libdir}/thumb/v7+fp/hard
%dir %{_libdir}/thumb/v7+fp/softfp

%dir %{_libdir}/thumb/v7-m
%dir %{_libdir}/thumb/v7-m/nofp
%dir %{_libdir}/thumb/v7-r+fp.sp
%dir %{_libdir}/thumb/v7-r+fp.sp/hard
%dir %{_libdir}/thumb/v7-r+fp.sp/softfp

%dir %{_libdir}/thumb/v7e-m
%dir %{_libdir}/thumb/v7e-m/nofp
%dir %{_libdir}/thumb/v7e-m+dp
%dir %{_libdir}/thumb/v7e-m+dp/hard
%dir %{_libdir}/thumb/v7e-m+dp/softfp
%dir %{_libdir}/thumb/v7e-m+fp
%dir %{_libdir}/thumb/v7e-m+fp/hard
%dir %{_libdir}/thumb/v7e-m+fp/softfp

%dir %{_libdir}/thumb/v8-m.base
%dir %{_libdir}/thumb/v8-m.base/nofp
%dir %{_libdir}/thumb/v8-m.main
%dir %{_libdir}/thumb/v8-m.main/nofp

%dir %{_libdir}/thumb/v8-m.main+dp
%dir %{_libdir}/thumb/v8-m.main+dp/hard
%dir %{_libdir}/thumb/v8-m.main+dp/softfp
%dir %{_libdir}/thumb/v8-m.main+fp
%dir %{_libdir}/thumb/v8-m.main+fp/hard
%dir %{_libdir}/thumb/v8-m.main+fp/softfp

%dir %{_libdir}/thumb/v8.1-m.main+mve
%dir %{_libdir}/thumb/v8.1-m.main+mve/hard


%{_libdir}/thumb/*/*/libm.a
%{_libdir}/thumb/*/*/libnosys.a

%{_includedir}
%{docdir}

%files libc
%{_libdir}/libc.a
%{_libdir}/libg.a
%{_libdir}/arm/v5te/*/libc.a
%{_libdir}/arm/v5te/*/libg.a

%{_libdir}/thumb/*/libc.a
%{_libdir}/thumb/*/libg.a
%{_libdir}/thumb/*/*/libc.a
%{_libdir}/thumb/*/*/libg.a


%files libc_nano
%{_libdir}/libc_nano.a
%{_libdir}/arm/v5te/*/libc_nano.a
%{_libdir}/thumb/*/libc_nano.a
%{_libdir}/thumb/*/*/libc_nano.a


%files misc
%{_libdir}/cpu-init
%{_libdir}/libgloss-linux.a
%{_libdir}/librd*
%{_libdir}/*.o
%{_libdir}/*.specs
%{_libdir}/redboot.ld

%{_libdir}/arm/v5te/*/cpu-init
%{_libdir}/arm/v5te/*/libgloss-linux.a
%{_libdir}/arm/v5te/*/librd*
%{_libdir}/arm/v5te/*/*.o
%{_libdir}/arm/v5te/*/*.specs
%{_libdir}/arm/v5te/*/redboot.ld


%{_libdir}/thumb/nofp/cpu-init
%{_libdir}/thumb/nofp/libgloss-linux.a
%{_libdir}/thumb/nofp/librd*
%{_libdir}/thumb/nofp/*.o
%{_libdir}/thumb/nofp/*.specs
%{_libdir}/thumb/nofp/redboot.ld

%{_libdir}/thumb/*/nofp/cpu-init
%{_libdir}/thumb/*/nofp/libgloss-linux.a
%{_libdir}/thumb/*/nofp/librd*
%{_libdir}/thumb/*/nofp/*.o
%{_libdir}/thumb/*/nofp/*.specs
%{_libdir}/thumb/*/nofp/redboot.ld

%{_libdir}/thumb/*/softfp/cpu-init
%{_libdir}/thumb/*/softfp/libgloss-linux.a
%{_libdir}/thumb/*/softfp/librd*
%{_libdir}/thumb/*/softfp/*.o
%{_libdir}/thumb/*/softfp/*.specs
%{_libdir}/thumb/*/softfp/redboot.ld

%{_libdir}/thumb/*/hard/cpu-init
%{_libdir}/thumb/*/hard/libgloss-linux.a
%{_libdir}/thumb/*/hard/librd*
%{_libdir}/thumb/*/hard/*.o
%{_libdir}/thumb/*/hard/*.specs
%{_libdir}/thumb/*/hard/redboot.ld
